/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton interface for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ACT_ACCEPT = 258,
     ACT_REJECT = 259,
     ACT_TEMPFAIL = 260,
     ACT_CONTINUE = 261,
     ACT_DISCARD = 262,
     ADD = 263,
     REPLACE = 264,
     DELETE = 265,
     PROG = 266,
     KW_BEGIN = 267,
     KW_END = 268,
     IF = 269,
     FI = 270,
     ELSE = 271,
     ELIF = 272,
     ON = 273,
     HOST = 274,
     FROM = 275,
     AS = 276,
     DO = 277,
     DONE = 278,
     POLL = 279,
     MATCHES = 280,
     FNMATCHES = 281,
     MXMATCHES = 282,
     MXFNMATCHES = 283,
     WHEN = 284,
     PASS = 285,
     SET = 286,
     CATCH = 287,
     THROW = 288,
     KW_ECHO = 289,
     RETURNS = 290,
     RETURN = 291,
     FUNC = 292,
     SWITCH = 293,
     CASE = 294,
     DEFAULT = 295,
     CONST = 296,
     FOR = 297,
     LOOP = 298,
     WHILE = 299,
     BREAK = 300,
     NEXT = 301,
     ARGCOUNT = 302,
     STRING = 303,
     CODE = 304,
     XCODE = 305,
     SYMBOL = 306,
     VARIABLE = 307,
     IDENTIFIER = 308,
     ARG = 309,
     NUMBER = 310,
     BACKREF = 311,
     BUILTIN = 312,
     BUILTIN_PROC = 313,
     BUILTIN_P = 314,
     OR = 315,
     AND = 316,
     EQ = 317,
     NE = 318,
     LT = 319,
     LE = 320,
     GT = 321,
     GE = 322,
     NOT = 323,
     LOGAND = 324,
     LOGOR = 325,
     LOGXOR = 326,
     LOGNOT = 327,
     FUNCTION = 328,
     FUNCTION_PROC = 329,
     FUNCTION_P = 330,
     TYPE = 331,
     CONCAT = 332,
     UMINUS = 333
   };
#endif
/* Tokens.  */
#define ACT_ACCEPT 258
#define ACT_REJECT 259
#define ACT_TEMPFAIL 260
#define ACT_CONTINUE 261
#define ACT_DISCARD 262
#define ADD 263
#define REPLACE 264
#define DELETE 265
#define PROG 266
#define KW_BEGIN 267
#define KW_END 268
#define IF 269
#define FI 270
#define ELSE 271
#define ELIF 272
#define ON 273
#define HOST 274
#define FROM 275
#define AS 276
#define DO 277
#define DONE 278
#define POLL 279
#define MATCHES 280
#define FNMATCHES 281
#define MXMATCHES 282
#define MXFNMATCHES 283
#define WHEN 284
#define PASS 285
#define SET 286
#define CATCH 287
#define THROW 288
#define KW_ECHO 289
#define RETURNS 290
#define RETURN 291
#define FUNC 292
#define SWITCH 293
#define CASE 294
#define DEFAULT 295
#define CONST 296
#define FOR 297
#define LOOP 298
#define WHILE 299
#define BREAK 300
#define NEXT 301
#define ARGCOUNT 302
#define STRING 303
#define CODE 304
#define XCODE 305
#define SYMBOL 306
#define VARIABLE 307
#define IDENTIFIER 308
#define ARG 309
#define NUMBER 310
#define BACKREF 311
#define BUILTIN 312
#define BUILTIN_PROC 313
#define BUILTIN_P 314
#define OR 315
#define AND 316
#define EQ 317
#define NE 318
#define LT 319
#define LE 320
#define GT 321
#define GE 322
#define NOT 323
#define LOGAND 324
#define LOGOR 325
#define LOGXOR 326
#define LOGNOT 327
#define FUNCTION 328
#define FUNCTION_PROC 329
#define FUNCTION_P 330
#define TYPE 331
#define CONCAT 332
#define UMINUS 333




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 288 "gram.y"
{
	struct literal *literal;
	struct stmtlist stmtlist;
	NODE *node;
	struct return_node ret;
	struct poll_data poll;
	struct locus locus;
	struct pollarg {
		int kw;
		NODE *expr;
	} pollarg;
	struct arglist {
		NODE *head;
		NODE *tail;
		size_t count;
	} arglist;
	long number;
	const struct builtin *builtin;
	struct variable *var;
	enum smtp_state state;
	struct {
		struct locus locus;
		int qualifier;
	} matchtype;
	data_type_t type;
	struct parmtype *parm;
	struct parmlist {
		struct parmtype *head, *tail;
		size_t count;
		size_t optcount;
	} parmlist;
	enum lexical_context tie_in;
	struct function *function;
	struct {
		struct valist *head, *tail;
	} valist_list;
	struct valist *valist;
	struct value value;
	struct {
		struct case_stmt *head, *tail;
	} case_list ;
	struct case_stmt *case_stmt;
	struct loop_node loop;
	struct {
		struct locus locus;
		int code;
	} progspecial;
}
/* Line 1489 of yacc.c.  */
#line 254 "gram.h"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

extern YYSTYPE yylval;

